/*

  8 Digit 7-Segment LED Display with Keys and LEDs - TM1638

  Parts required:
  - Arduino Board
  - 8 Digit 7-Segment LED Display with Keys and LEDs - TM1638

  Libraries required:
  - TM1638lite

  Programming by : René Rasmussen
  Website : www.it-teknolog.dk
  Contact : renerasmussen@it-teknolog.dk
  Date : 21 Mar 2020
  Version : v1.0

  Modulet kan købes på www.arduinotech.dk

*/
  
#include <TM1638lite.h>                                   // include library TM1638lite.h

TM1638lite tm(2, 3, 4);                                   // create object th fram TM1638lite.h and set digital ports

void setup() {
  tm.reset();                                             // reset the display
}

void loop() {
  uint8_t buttons = tm.readButtons();                     // read for button press
  doLEDs(buttons);                                        // run function doLEDs with the button number

  tm.displayText("12345678");                             // print text to display
  delay(2000);                                            // wait for 2000ms
}

// scans the individual bits of value
void doLEDs(uint8_t value) {                              // create function doLEDs()
  for (uint8_t position = 0; position < 8; position++) {  // for position = 0 to 8 do
    tm.setLED(position, value & 1);                       // run tm.setLED with data position and values
    value = value >> 1;                                   // set value to value and bitshift with 1
  }
}
